Index: /trunk/src/sys/arch/mips/mips/mipsX_subr.S
===================================================================
--- /trunk/src/sys/arch/mips/mips/mipsX_subr.S	(revision 151)
+++ /trunk/src/sys/arch/mips/mips/mipsX_subr.S	(revision 152)
@@ -887,464 +1217,25 @@
  * Check pending asynchronous traps.
  */
-	INT_L	t0, L_MD_ASTPENDING(MIPS_CURLWP)
-	beqz	t0, MIPSX(user_return)
+	INT_L	v0, L_MD_ASTPENDING(MIPS_CURLWP)# any pending ast?
+	beqz	v0, MIPSX(user_return)		# if no, skip ast processing
 	 nop
 /*
  * We have pending asynchronous traps; all the state is already saved.
  */
-	PTR_LA	ra, MIPSX(user_return)
+	lui	ra, %hi(MIPSX(user_return))	# return directly to user return
 	j	_C_LABEL(ast)
-	 nop
+	 PTR_ADDIU ra, %lo(MIPSX(user_return))	# return directly to user return
 	.set	at
 END(MIPSX(user_gen_exception))
 
-/*
- * mipsN_systemcall
- *
- * Save user context in u_pcb, then call syscall() to process a system call.
- * The context can be manipulated alternatively via curlwp->p_md.md_regs;
- */
-	.p2align 5
-NESTED_NOPROFILE(MIPSX(systemcall), CALLFRAME_SIZ, ra)
-	.set	noat
-	.mask	0x80000000, -4
-	/* k1 already cpulwp */
-	PTR_L	k0, L_ADDR(k1)
-	#nop					# -slip-
-	PTR_ADDU k0, k0, USPACE - TF_SIZ - CALLFRAME_SIZ
-	REG_S	AT, CALLFRAME_SIZ+TF_REG_AST(k0)
-	REG_S	v0, CALLFRAME_SIZ+TF_REG_V0(k0)		# syscall #
-	REG_S	v1, CALLFRAME_SIZ+TF_REG_V1(k0)		# used by syscall()
-	mflo	v0
-	REG_S	a0, CALLFRAME_SIZ+TF_REG_A0(k0)
-	REG_S	a1, CALLFRAME_SIZ+TF_REG_A1(k0)
-	REG_S	a2, CALLFRAME_SIZ+TF_REG_A2(k0)
-	REG_S	a3, CALLFRAME_SIZ+TF_REG_A3(k0)
-	move	a0, k1				# 1st arg is curlwp
-	mfhi	v1
-	mfc0	a2, MIPS_COP_0_CAUSE		# 3rd arg is CAUSE
-	REG_S	s0, CALLFRAME_SIZ+TF_REG_S0(k0)
-	REG_S	s1, CALLFRAME_SIZ+TF_REG_S1(k0)
-	REG_S	s2, CALLFRAME_SIZ+TF_REG_S2(k0)
-	REG_S	s3, CALLFRAME_SIZ+TF_REG_S3(k0)
-	_MFC0	a3, MIPS_COP_0_EXC_PC		# 4th arg is PC
-	REG_S	s4, CALLFRAME_SIZ+TF_REG_S4(k0)
-	REG_S	s5, CALLFRAME_SIZ+TF_REG_S5(k0)
-	REG_S	s6, CALLFRAME_SIZ+TF_REG_S6(k0)
-	REG_S	s7, CALLFRAME_SIZ+TF_REG_S7(k0)
-	REG_S	t0, CALLFRAME_SIZ+TF_REG_T0(k0)
-	REG_S	t1, CALLFRAME_SIZ+TF_REG_T1(k0)
-	REG_S	t2, CALLFRAME_SIZ+TF_REG_T2(k0)
-	REG_S	t3, CALLFRAME_SIZ+TF_REG_T3(k0)		# syscall saved gp for fork
-	mfc0	a1, MIPS_COP_0_STATUS		# 2nd arg is STATUS
-#if defined(__mips_n32) || defined(__mips_n64)
-	REG_S	a4, CALLFRAME_SIZ+TF_REG_A4(k0)
-	REG_S	a5, CALLFRAME_SIZ+TF_REG_A5(k0)
-	REG_S	a6, CALLFRAME_SIZ+TF_REG_A6(k0)
-	REG_S	a7, CALLFRAME_SIZ+TF_REG_A7(k0)
-#else
-	REG_S	ta0, CALLFRAME_SIZ+TF_REG_TA0(k0)
-	REG_S	ta1, CALLFRAME_SIZ+TF_REG_TA1(k0)
-	REG_S	ta2, CALLFRAME_SIZ+TF_REG_TA2(k0)
-	REG_S	ta3, CALLFRAME_SIZ+TF_REG_TA3(k0)
-#endif
-	REG_S	t8, CALLFRAME_SIZ+TF_REG_T8(k0)	# was MIPS_CURLWP
-	REG_S	t9, CALLFRAME_SIZ+TF_REG_T9(k0)
-	REG_S	gp, CALLFRAME_SIZ+TF_REG_GP(k0)
-	REG_S	sp, CALLFRAME_SIZ+TF_REG_SP(k0)
-	REG_S	s8, CALLFRAME_SIZ+TF_REG_S8(k0)
-	REG_S	ra, CALLFRAME_SIZ+TF_REG_RA(k0)
-	REG_S	a1, CALLFRAME_SIZ+TF_REG_SR(k0)
-	REG_S	v0, CALLFRAME_SIZ+TF_REG_MULLO(k0)
-	REG_S	v1, CALLFRAME_SIZ+TF_REG_MULHI(k0)
-	REG_S	a3, CALLFRAME_SIZ+TF_REG_EPC(k0)
-	PTR_L	t0, L_PROC(a0)			# curlwp->l_proc (used below)
-	move	sp, k0
-	move	MIPS_CURLWP, a0			# set curlwp reg
-#ifdef __GP_SUPPORT__
-	PTR_LA	gp, _C_LABEL(_gp)		# switch to kernel GP
-#endif
-#if defined(DDB) || defined(DEBUG) || defined(KGDB)
-	move	ra, a3
-	REG_S	ra, CALLFRAME_RA(sp)
-#endif
-/*
- * Turn off fpu and enter kernel mode
- */
-	PTR_L	t9, P_MD_SYSCALL(t0)		# t1 = syscall
-#ifdef NOFPU
-	and	t0, a1, MIPS_SR_EXL|MIPS_SR_KSU_MASK
-	xor	t0, a1
-#else
-	lui	t0, %hi(~(MIPS_SR_COP_1_BIT|MIPS_SR_EXL|MIPS_SR_KSU_MASK))
-	ori	t0, %lo(~(MIPS_SR_COP_1_BIT|MIPS_SR_EXL|MIPS_SR_KSU_MASK))
-	and	t0, a1
-#endif
-	mtc0	t0, MIPS_COP_0_STATUS		# re-enable interrupts
-	COP0_SYNC
-/*
- * Call the system call handler.
- */
-	jal	t9
-	nop
-/*
- * Check pending asynchronous traps.
- */
-	INT_L	t0, L_MD_ASTPENDING(MIPS_CURLWP)
-	beqz	t0, MIPSX(user_return)
-	 nop
-/*
- * We have pending asynchronous traps; all the state is already saved.
- */
-	PTR_LA	ra, MIPSX(user_return)
-	j	_C_LABEL(ast)
-	 nop
-	.set	at
-END(MIPSX(systemcall))
-
-/*
- * Panic on cache errors.  A lot more could be done to recover
- * from some types of errors but it is tricky.
- */
-	.p2align 5
-NESTED_NOPROFILE(MIPSX(cache_exception), KERNFRAME_SIZ, ra)
-	.set	noat
-	.mask	0x80000000, -4
-#ifdef sbmips	/* XXX!  SB-1 needs a real cache error handler */
-	eret
-	nop
-#endif
-	PTR_LA	k0, panic			# return to panic
-	PTR_LA	a0, 9f				# panicstr
-	_MFC0	a1, MIPS_COP_0_ERROR_PC
-#if defined(MIPS64_XLS)
-	li	k1, 0x309	/* L1D_CACHE_ERROR_LOG */
-	mfcr	a2, k1
-	li	k1, 0x30b	/* L1D_CACHE_INTERRUPT */
-	mfcr	a3, k1
-#if defined(__mips_o32)
-#error O32 not supported.
-#endif
-	mfc0	a4, MIPS_COP_0_STATUS
-	mfc0	a5, MIPS_COP_0_CAUSE
-#else
-	mfc0	a2, MIPS_COP_0_ECC
-	mfc0	a3, MIPS_COP_0_CACHE_ERR
-#endif
-
-	_MTC0	k0, MIPS_COP_0_ERROR_PC		# set return address
-	COP0_SYNC
-
-	mfc0	k0, MIPS_COP_0_STATUS		# restore status
-	li	k1, MIPS3_SR_DIAG_PE		# ignore further errors
-	or	k0, k1
-	mtc0	k0, MIPS_COP_0_STATUS		# restore status
-	COP0_SYNC
-	nop
-	nop
-	nop
-
-	eret
-
-#if defined(MIPS64_XLS)
-	MSG("cache error @ EPC %#lx\nL1D_CACHE_ERROR_LOG %#lx\nL1D_CACHE_INTERRUPT %#lx\nstatus %#x, cause %#x");
-#else
-	MSG("cache error @ EPC 0x%x ErrCtl 0x%x CacheErr 0x%x");
-#endif
-	.set	at
-END(MIPSX(cache_exception))
-
-/*
- * mipsX_kern_intr
- *
- * Handle an interrupt from kernel mode.
- * Build intrframe on stack to hold interrupted kernel context, then
- * call cpu_intr() to process it.
- *
- */
-	.p2align 5
-NESTED_NOPROFILE(MIPSX(kern_intr), KERNFRAME_SIZ, ra)
-	.set	noat
-	.mask	0x80000000, -4
-#ifdef PARANOIA
-	PTR_L	k0, L_ADDR(k1)
-	slt	k0, k0, sp			# k0 = L_ADDR(k1) < sp
-1:	beqz	k0, 1b				# loop forever if false
-	 nop
-	PTR_L	k0, L_ADDR(k1)
-	PTR_ADDU k0, USPACE
-	slt	k0, sp, k0			# k0 = sp < L_ADDR(k1) + USPACE
-2:	beqz	k0, 2b				# loop forever if false
-	 nop
-	PTR_L	k0, L_CPU(k1)
-	INT_L	k0, CPU_INFO_IDEPTH(k0)		# grab interrupt depth
-	sltu	k0, k0, 3			# must be < 3
-3:	beqz	k0, 3b				# loop forever if false
-	 nop
-#endif
-/*
- * Save the relevant kernel registers onto the stack.
- * We don't need to save s0 - s8, sp and gp because
- * the compiler does it for us.
- */
-	PTR_SUBU sp, sp, KERNFRAME_SIZ
-	REG_S	AT, TF_BASE+TF_REG_AST(sp)
-	REG_S	v0, TF_BASE+TF_REG_V0(sp)
-	REG_S	v1, TF_BASE+TF_REG_V1(sp)
-	mflo	v0
-	mfhi	v1
-	REG_S	a0, TF_BASE+TF_REG_A0(sp)
-	REG_S	a1, TF_BASE+TF_REG_A1(sp)
-	REG_S	a2, TF_BASE+TF_REG_A2(sp)
-	REG_S	a3, TF_BASE+TF_REG_A3(sp)
-	REG_S	t0, TF_BASE+TF_REG_T0(sp)
-	REG_S	t1, TF_BASE+TF_REG_T1(sp)
-	REG_S	t2, TF_BASE+TF_REG_T2(sp)
-	REG_S	t3, TF_BASE+TF_REG_T3(sp)
-	REG_S	ta0, TF_BASE+TF_REG_TA0(sp)
-	REG_S	ta1, TF_BASE+TF_REG_TA1(sp)
-	REG_S	ta2, TF_BASE+TF_REG_TA2(sp)
-	REG_S	ta3, TF_BASE+TF_REG_TA3(sp)
-	REG_S	s0, TF_BASE+TF_REG_S0(sp)	# s0 is used for saved ipl
-	REG_S	s1, TF_BASE+TF_REG_S1(sp)	# s1 is used for initial status
-	mfc0	s1, MIPS_COP_0_STATUS
-	REG_S	s2, TF_BASE+TF_REG_S2(sp)	# s2 is used for cpu_info
-	REG_S	t8, TF_BASE+TF_REG_T8(sp)	# MIPS_CURLWP
-	REG_S	t9, TF_BASE+TF_REG_T9(sp)
-	REG_S	ra, TF_BASE+TF_REG_RA(sp)
-	REG_S	a0, TF_BASE+TF_REG_SR(sp)
-	REG_S	v0, TF_BASE+TF_REG_MULLO(sp)
-	REG_S	v1, TF_BASE+TF_REG_MULHI(sp)
-/*
- * Call the interrupt handler.
- */
-	_MFC0	ra, MIPS_COP_0_EXC_PC		# grab exception PC
-	REG_S	ra, TF_BASE+TF_REG_EPC(sp)	# and save it
-
-#if defined(DDB) || defined(DEBUG) || defined(KGDB)
-	REG_S	ra, KERNFRAME_RA(sp)		# for debugging
-#endif
-
-	PTR_L	s2, L_CPU(MIPS_CURLWP)
-#ifdef PARANOIA
-	INT_L	s0, CPU_INFO_CPL(s2)
-	INT_S	s0, TF_BASE+TF_PPL(sp)		# save priority level
-
-	/*
-	 * Verify the current interrupt level
-	 */
-	PTR_L	t9, _C_LABEL(mips_splsw) + SPLSW_SPLCHECK
-	jalr	t9
-	 nop
-#endif /* PARANOIA */
-
-	/*
-	 * We first need to get to IPL_HIGH so that interrupts are masked.
-	 */
-	jal	_C_LABEL(splhigh_noprof)
-	 nop
-
-#ifdef PARANOIA
-1:	bne	s0, v0, 1b
-	 nop
-#endif /* PARANOIA */
-
-	sll	s0, v0, 8			# remember previous priority
-						# low 8 bits used for idepth
-
-#ifdef PARANOIA
-	/*
-	 * Interrupts at IPL_HIGH are not allowed.
-	 */
-	li	v1, IPL_HIGH
-	sltu	t0, v0, v1
-2:	beqz	t0, 2b
-	 nop
-#endif /* PARANOIA */
-
-	INT_L	t1, CPU_INFO_IDEPTH(s2)		# we need to inc. intr depth
-	or	s0, t1				#   save old interrupt depth
-	INT_ADDU t1, 1
-	INT_S	t1, CPU_INFO_IDEPTH(s2)		#   store new interrupt depth
-
-	/*
-	 * Now we can clear exception level since no interrupts can be delivered
-	 */
-	mfc0	v1, MIPS_COP_0_STATUS
-	and	v0, v1, MIPS_SR_EXL		# grab exception level bit
-	xor	v0, v1				# clear it
-	mtc0	v0, MIPS_COP_0_STATUS		# write new status
-	COP0_SYNC
-
-	/*
-	 * Now hard interrupts can be processed.
-	 */
-	REG_L	ra, TF_BASE+TF_REG_EPC(sp)
-	move	a1, ra				# 2nd arg is exception pc
-	move	a2, s1				# 3rd arg is status
-	jal	_C_LABEL(cpu_intr)		# cpu_intr(ppl, pc, status)
-	 srl	a0, s0, 8			# 1st arg is previous pri level
-
-	and	t1, s0, 0xff			# get previous interrupt depth
-	INT_S	t1, CPU_INFO_IDEPTH(s2)		# to it previous value
-
-#ifdef PARANOIA
-	mfc0	t0, MIPS_COP_0_STATUS		# verify INT_IE is still set
-	and	t0, MIPS_SR_INT_IE
-3:	beqz	t0, 3b
-	 nop
-#endif /* PARANOIA */
-
-#ifdef __HAVE_FAST_SOFTINTS
-	and	a0, s1, MIPS_SOFT_INT_MASK	# were softints enabled?
-	beqz	a0, 4f				#   nope
-	 nop
-	mfc0	v0, MIPS_COP_0_CAUSE		# grab the pending softints
-	and	a0, v0				# are softints pending
-	beqz	a0, 4f				#   nope
-	 nop
-
-	jal	_C_LABEL(softint_process)	# softint_process(pending)
-	 nop
-
-#ifdef __HAVE_PREEMPTION
-	srl	v1, s0, 8			# get saved priority level
-	bnez	v1, 4f				# branch if not at IPL_NONE
-	 nop
-	INT_L	t0, CPU_INFO_SOFTINTS(s2)	# get pending softints
-	and	v0, t0, 1 << SOFTINT_KPREEMPT	# do we need a kernel preempt?
-	beqz	v0, 4f				#   nop
-	 nop
-	xor	t0, v0				# clear preempt bit
-	INT_S	t0, CPU_INFO_SOFTINTS(s2)	# and save it.
-	jal	_C_LABEL(kpreempt)		# kpreempt(pc)
-	 PTR_L	a0, TF_BASE+TF_REG_EPC(sp)
-#endif /* __HAVE_PREEMPTION */
-4:
-#endif /* __HAVE_FAST_SOFTINT */
-/*
- * Restore registers and return from the interrupt.
- */
-	/*
-	 * Clear interrupt enable
-	 */
-	mfc0	v0, MIPS_COP_0_STATUS		# read it 
-	xor	v0, MIPS_SR_INT_IE		# disable interrupts
-	mtc0	v0, MIPS_COP_0_STATUS		# write it
-	COP0_SYNC
-	nop
-	nop
-	nop
-
-	or	v0, MIPS_SR_EXL			# set exception mode
-	mtc0	v0, MIPS_COP_0_STATUS		# write it
-	COP0_SYNC
-	nop
-	nop
-	nop
-
-	srl	a0, s0, 8			# get previous priority level
-#ifdef PARANOIA
-	INT_L	t0, TF_BASE+TF_PPL(sp)		# get saved priority level
-9:	bne	t0, a0, 9b			# should still match
-	 nop
-
-	li	t0, IPL_HIGH
-	sltu	v0, a0, t0
-8:	beqz	v0, 8b
-	 nop
-#endif /* PARANOIA */
-
-	/*
-	 * Restore IPL knowing interrupts are disabled
-	 */
-	jal	_C_LABEL(splx_noprof)		# splx(ppl)
-	 nop
-
-#ifdef PARANOIA
-	mfc0	v0, MIPS_COP_0_STATUS
-	or	v0, MIPS_SR_INT_IE
-5:	bne	v0, s1, 5b
-	 nop
-#endif /* PARANOIA */
-
-	/*
-	 * Restore SR
-	 */
-	mtc0	s1, MIPS_COP_0_STATUS
-	COP0_SYNC
-	nop
-	nop
-	nop
-
-	REG_L	t0, TF_BASE+TF_REG_MULLO(sp)
-	REG_L	t1, TF_BASE+TF_REG_MULHI(sp)
-	REG_L	v0, TF_BASE+TF_REG_EPC(sp)
-	mtlo	t0
-	mthi	t1
-
-#ifdef notyet
-	/* Check for restartable sequences. */
-	lui	t0, %hi(_C_LABEL(_lock_ras_start))
-	ori	t0, zero, %lo(_C_LABEL(_lock_ras_start))
-	li	t1, -MIPS_LOCK_RAS_SIZE
-	and	t1, t1, v0
-	bne	t1, t0, 10f
-	move	k1, v0
-	jal	_C_LABEL(_lock_ras)
-	nop
-	mov	v0, k1
-#endif
-
-10:	_MTC0	v0, MIPS_COP_0_EXC_PC		# set return address
-	COP0_SYNC
-
-#ifdef PARANOIA
-	INT_L	t2, TF_BASE+TF_PPL(sp)		# get saved priority level
-	INT_L	t1, CPU_INFO_CPL(s2)		# get current priority level
-11:	bne	t2, t1, 11b			# loop forever is unequal
-	 nop
-
-	PTR_L	t9, _C_LABEL(mips_splsw) + SPLSW_SPLCHECK
-	jalr	t9
-	 nop
-#endif /* PARANOIA */
-
-	REG_L	AT, TF_BASE+TF_REG_AST(sp)
-	REG_L	v0, TF_BASE+TF_REG_V0(sp)
-	REG_L	v1, TF_BASE+TF_REG_V1(sp)
-	REG_L	a0, TF_BASE+TF_REG_A0(sp)
-	REG_L	a1, TF_BASE+TF_REG_A1(sp)
-	REG_L	a2, TF_BASE+TF_REG_A2(sp)
-	REG_L	a3, TF_BASE+TF_REG_A3(sp)
-	REG_L	t0, TF_BASE+TF_REG_T0(sp)
-	REG_L	t1, TF_BASE+TF_REG_T1(sp)
-	REG_L	t2, TF_BASE+TF_REG_T2(sp)
-	REG_L	t3, TF_BASE+TF_REG_T3(sp)
-	REG_L	ta0, TF_BASE+TF_REG_TA0(sp)
-	REG_L	ta1, TF_BASE+TF_REG_TA1(sp)
-	REG_L	ta2, TF_BASE+TF_REG_TA2(sp)
-	REG_L	ta3, TF_BASE+TF_REG_TA3(sp)
-	REG_L	s0, TF_BASE+TF_REG_S0(sp)
-	REG_L	s1, TF_BASE+TF_REG_S1(sp)
-	REG_L	s2, TF_BASE+TF_REG_S2(sp)
-	REG_L	t8, TF_BASE+TF_REG_T8(sp)	# MIPS_CURLWP
-	REG_L	t9, TF_BASE+TF_REG_T9(sp)
-	REG_L	ra, TF_BASE+TF_REG_RA(sp)
-	PTR_ADDU sp, sp, KERNFRAME_SIZ		# restore kernel SP
-	eret					# return to interrupted point
-	.set	at
-END(MIPSX(kern_intr))
-
 /*----------------------------------------------------------------------------
- * XXX this comment block should be updated XXX
- * mipsN_user_intr --
+ *
+ * mipsN_user_intr
  *
  *	Handle an interrupt from user mode.
- *	Note: we save minimal state in the u.u_pcb struct and use the standard
- *	kernel stack since there has to be a u page if we came from user mode.
- *	If there is a pending software interrupt, then save the remaining state
- *	and call softintr(). This is all because if we call switch() inside
- *	cpu_intr(), not all the user registers have been saved in u.u_pcb.
+ *	We save partial state onto the kernel stack since we know there will
+ *	always a kernel stack and chances are we won't need the registers we
+ *	don't save.  If there is a pending asynchronous system trap, then save
+ *	the remaining state and call ast().
  *
  * Results:
@@ -1361,10 +1252,10 @@
 	.mask	0x80000000, -4
 /*
- * Save the relevant user registers into the u_pcb.
+ * Save the relevant user registers onto the kernel stack.
  * We don't need to save s0 - s8 because the compiler does it for us.
  */
 	/* k1 contains curlwp */
-	PTR_L	k0, L_ADDR(k1)
-	PTR_ADDU k0, k0, USPACE - TF_SIZ - CALLFRAME_SIZ
+	PTR_L	k0, L_PCB(k1)			# XXXuvm_lwp_getuarea
+	PTR_ADDU k0, USPACE - TF_SIZ - CALLFRAME_SIZ
 	REG_S	AT, CALLFRAME_SIZ+TF_REG_AST(k0)	# $1
 	REG_S	v0, CALLFRAME_SIZ+TF_REG_V0(k0)		# $2
@@ -1377,8 +1268,8 @@
 	mfhi	v1
 	REG_S	t0, CALLFRAME_SIZ+TF_REG_T0(k0)		# $12
-	mfc0	t0, MIPS_COP_0_CAUSE
 	REG_S	t1, CALLFRAME_SIZ+TF_REG_T1(k0)		# $13
 	REG_S	t2, CALLFRAME_SIZ+TF_REG_T2(k0)		# $14
 	REG_S	t3, CALLFRAME_SIZ+TF_REG_T3(k0)		# $15
+	mfc0	t0, MIPS_COP_0_CAUSE
 	REG_S	ta0, CALLFRAME_SIZ+TF_REG_TA0(k0)	# $8
 	REG_S	ta1, CALLFRAME_SIZ+TF_REG_TA1(k0)	# $9
@@ -1394,13 +1285,13 @@
 	REG_S	ra, CALLFRAME_SIZ+TF_REG_RA(k0)		# $31
 	REG_S	s1, CALLFRAME_SIZ+TF_REG_SR(k0)
-	_MFC0	ra, MIPS_COP_0_EXC_PC
+	_MFC0	ta0, MIPS_COP_0_EXC_PC
 	REG_S	v0, CALLFRAME_SIZ+TF_REG_MULLO(k0)
 	REG_S	v1, CALLFRAME_SIZ+TF_REG_MULHI(k0)
-	REG_S	ra, CALLFRAME_SIZ+TF_REG_EPC(k0)
+	REG_S	ta0, CALLFRAME_SIZ+TF_REG_EPC(k0)
 	REG_S	t0, CALLFRAME_SIZ+TF_REG_CAUSE(k0)
-	move	sp, k0
+	move	sp, k0				# switch to kernel SP
 	move	MIPS_CURLWP, k1			# set curlwp reg (t8)
 #if defined(DDB) || defined(DEBUG) || defined(KGDB)
-	REG_S	ra, CALLFRAME_RA(sp)
+	REG_S	ta0, CALLFRAME_RA(sp)		# for debugging
 #endif
 #ifdef __GP_SUPPORT__
@@ -1425,5 +1316,5 @@
 #else
 	lui	v0, %hi(~(MIPS_SR_COP_1_BIT|MIPS_SR_EXL|MIPS_SR_KSU_MASK))
-	ori	v0, %lo(~(MIPS_SR_COP_1_BIT|MIPS_SR_EXL|MIPS_SR_KSU_MASK))
+	addiu	v0, %lo(~(MIPS_SR_COP_1_BIT|MIPS_SR_EXL|MIPS_SR_KSU_MASK))
 	and	v0, v1 
 #endif
@@ -1441,6 +1332,5 @@
 	 * Now hard interrupts can be processed.
 	 */
-	REG_L	ra, CALLFRAME_SIZ+TF_REG_EPC(sp)
-	move	a1, ra				# 2nd arg is exception pc
+	move	a1, ta0				# 2nd arg is exception pc
 	move	a2, s1				# 3rd arg is status
 	jal	_C_LABEL(cpu_intr)		# cpu_intr(ppl, pc, status)
@@ -1480,7 +1370,4 @@
 	mtc0	v0, MIPS_COP_0_STATUS		# interrupts are disabled
 	COP0_SYNC
-	nop
-	nop
-	nop
 
 	/*
@@ -1490,7 +1377,7 @@
 	 move	a0, s0				# fetch previous priority level
 
-/*
- * Check pending asynchronous traps.
- */
+	/*
+	 * Check pending asynchronous traps.
+	 */
 	REG_L	s0, CALLFRAME_SIZ+TF_REG_S0(sp)	# restore
 	REG_L	s1, CALLFRAME_SIZ+TF_REG_S1(sp)	# restore
@@ -1498,9 +1385,11 @@
 	beqz	v0, MIPSX(user_intr_return)	# if no, skip ast processing
 	 nop
-/*
- * We have pending asynchronous traps; save remaining user state in u_pcb.
- */
-	#REG_S	s0, CALLFRAME_SIZ+TF_REG_S0(sp)	# $16 saved above
-	#REG_S	s1, CALLFRAME_SIZ+TF_REG_S1(sp)	# $17 saved above
+
+	/*
+	 * We have a pending asynchronous trap; save remaining user state into
+	 * trapframe.
+	 */
+	#REG_S	s0, CALLFRAME_SIZ+TF_REG_S0(sp)	# $16 (saved above)
+	#REG_S	s1, CALLFRAME_SIZ+TF_REG_S1(sp)	# $17 (saved above)
 	REG_S	s2, CALLFRAME_SIZ+TF_REG_S2(sp)	# $18
 	REG_S	s3, CALLFRAME_SIZ+TF_REG_S3(sp)	# $19
@@ -1515,25 +1404,264 @@
 	mtc0	t0, MIPS_COP_0_STATUS		# enable interrupts (spl0)
 	COP0_SYNC
+
+	PTR_LA	ra, MIPSX(user_return)
+	j	_C_LABEL(ast)			# ast()
+	 nop
+	.set	at
+END(MIPSX(user_intr))
+
+/*
+ * mipsN_systemcall
+ *
+ * Save user context atop of kernel stack, then call syscall() to process
+ * a system call.  The context can be manipulated alternatively via
+ * curlwp->l_md.md_utf->tf_regs.
+ */
+	.p2align 5
+NESTED_NOPROFILE(MIPSX(systemcall), CALLFRAME_SIZ, ra)
+	.set	noat
+	.mask	0x80000000, -4
+	/*
+	 * Save all the registers but kernel temporaries onto the stack.
+	 */
+	/* k1 already contains cpulwp */
+	PTR_L	k0, L_PCB(k1)			# XXXuvm_lwp_getuarea
+	PTR_ADDU k0, USPACE - TF_SIZ - CALLFRAME_SIZ
+	#REG_S	AT, CALLFRAME_SIZ+TF_REG_AST(k0)
+	#.set	at
+	REG_S	v0, CALLFRAME_SIZ+TF_REG_V0(k0)		# syscall #
+	REG_S	v1, CALLFRAME_SIZ+TF_REG_V1(k0)		# used by syscall()
+	mflo	v0
+	REG_S	a0, CALLFRAME_SIZ+TF_REG_A0(k0)
+	REG_S	a1, CALLFRAME_SIZ+TF_REG_A1(k0)
+	REG_S	a2, CALLFRAME_SIZ+TF_REG_A2(k0)
+	REG_S	a3, CALLFRAME_SIZ+TF_REG_A3(k0)
+	mfhi	v1
+	mfc0	a1, MIPS_COP_0_STATUS			# 2nd arg is STATUS
+	REG_S	s0, CALLFRAME_SIZ+TF_REG_S0(k0)
+	REG_S	s1, CALLFRAME_SIZ+TF_REG_S1(k0)
+	REG_S	s2, CALLFRAME_SIZ+TF_REG_S2(k0)
+	REG_S	s3, CALLFRAME_SIZ+TF_REG_S3(k0)
+	mfc0	a2, MIPS_COP_0_CAUSE			# 3rd arg is CAUSE
+	REG_S	s4, CALLFRAME_SIZ+TF_REG_S4(k0)
+	REG_S	s5, CALLFRAME_SIZ+TF_REG_S5(k0)
+	REG_S	s6, CALLFRAME_SIZ+TF_REG_S6(k0)
+	REG_S	s7, CALLFRAME_SIZ+TF_REG_S7(k0)
+	_MFC0	a3, MIPS_COP_0_EXC_PC			# 4th arg is PC
+	REG_S	t0, CALLFRAME_SIZ+TF_REG_T0(k0)
+	REG_S	t1, CALLFRAME_SIZ+TF_REG_T1(k0)
+	REG_S	t2, CALLFRAME_SIZ+TF_REG_T2(k0)
+	REG_S	t3, CALLFRAME_SIZ+TF_REG_T3(k0)		# syscall saved gp for fork
+#if defined(__mips_n32) || defined(__mips_n64)
+	REG_S	a4, CALLFRAME_SIZ+TF_REG_A4(k0)
+	REG_S	a5, CALLFRAME_SIZ+TF_REG_A5(k0)
+	REG_S	a6, CALLFRAME_SIZ+TF_REG_A6(k0)
+	REG_S	a7, CALLFRAME_SIZ+TF_REG_A7(k0)
+#else
+	REG_S	ta0, CALLFRAME_SIZ+TF_REG_TA0(k0)
+	REG_S	ta1, CALLFRAME_SIZ+TF_REG_TA1(k0)
+	REG_S	ta2, CALLFRAME_SIZ+TF_REG_TA2(k0)
+	REG_S	ta3, CALLFRAME_SIZ+TF_REG_TA3(k0)
+#endif
+	REG_S	t8, CALLFRAME_SIZ+TF_REG_T8(k0)		# will be MIPS_CURLWP
+	REG_S	t9, CALLFRAME_SIZ+TF_REG_T9(k0)
+	REG_S	gp, CALLFRAME_SIZ+TF_REG_GP(k0)
+	REG_S	sp, CALLFRAME_SIZ+TF_REG_SP(k0)
+	REG_S	s8, CALLFRAME_SIZ+TF_REG_S8(k0)
+	REG_S	ra, CALLFRAME_SIZ+TF_REG_RA(k0)
+	REG_S	a1, CALLFRAME_SIZ+TF_REG_SR(k0)
+	REG_S	v0, CALLFRAME_SIZ+TF_REG_MULLO(k0)
+	REG_S	v1, CALLFRAME_SIZ+TF_REG_MULHI(k0)
+	REG_S	a3, CALLFRAME_SIZ+TF_REG_EPC(k0)
+	move	MIPS_CURLWP, k1			# set curlwp reg
+	move	sp, k0				# switch to kernel SP
+#ifdef __GP_SUPPORT__
+	PTR_LA	gp, _C_LABEL(_gp)		# switch to kernel GP
+#endif
+#if defined(DDB) || defined(DEBUG) || defined(KGDB)
+	move	ra, a3
+	REG_S	ra, CALLFRAME_RA(sp)
+#endif
+	PTR_L	s0, L_PROC(MIPS_CURLWP)		# curlwp->l_proc
+	PTR_L	t9, P_MD_SYSCALL(s0)		# t9 = syscall
+	/*
+	 * Turn off FPU and enter kernel mode
+	 */
+#ifdef NOFPU
+	lui	t0, %hi(~(MIPS_SR_COP_1_BIT|MIPS_SR_EXL|MIPS_SR_KSU_MASK))
+	addiu	t0, %lo(~(MIPS_SR_COP_1_BIT|MIPS_SR_EXL|MIPS_SR_KSU_MASK))
+	and	t0, a1
+#else
+	and	t0, a1, MIPS_SR_EXL|MIPS_SR_KSU_MASK
+	xor	t0, a1				# turns off the FPU & ints on
+#endif
+	mtc0	t0, MIPS_COP_0_STATUS		# re-enable interrupts
+	COP0_SYNC
+/*
+ * Call the system call handler.
+ */
+	jalr	t9
+	 move	a0, MIPS_CURLWP			# 1st arg is curlwp
+
+/*
+ * Check pending asynchronous traps.
+ */
+	INT_L	v0, L_MD_ASTPENDING(MIPS_CURLWP)# any pending ast?
+	beqz	v0, MIPSX(user_return)		# no, skip ast processing
+	 nop
+/*
+ * We have pending asynchronous traps; all the state is already saved.
+ */
+	lui	ra, %hi(MIPSX(user_return))	# return directly to user return
+	j	_C_LABEL(ast)
+	 PTR_ADDIU ra, %lo(MIPSX(user_return))	# return directly to user return
+	.set	at
+END(MIPSX(systemcall))
+
+/*
+ * Panic on cache errors.  A lot more could be done to recover
+ * from some types of errors but it is tricky.
+ */
+	.p2align 5
+NESTED_NOPROFILE(MIPSX(cache_exception), KERNFRAME_SIZ, ra)
+	.set	noat
+	.mask	0x80000000, -4
+#ifdef sbmips	/* XXX!  SB-1 needs a real cache error handler */
+	eret
+	nop
+#endif
+	PTR_LA	k0, panic			# return to panic
+	PTR_LA	a0, 9f				# panicstr
+	_MFC0	a1, MIPS_COP_0_ERROR_PC
+#if (MIPS64_RMIXL + MIPS64R2_RMIXL) > 0
+	.set	push
+	.set	arch=xlr
+	li	k1, 0x309	/* L1D_CACHE_ERROR_LOG */
+	mfcr	a2, k1
+	li	k1, 0x30b	/* L1D_CACHE_INTERRUPT */
+	mfcr	a3, k1
+	.set	pop
+#if defined(__mips_o32)
+#error O32 not supported.
+#endif
+	mfc0	a4, MIPS_COP_0_STATUS
+	mfc0	a5, MIPS_COP_0_CAUSE
+#else
+	mfc0	a2, MIPS_COP_0_ECC
+	mfc0	a3, MIPS_COP_0_CACHE_ERR
+#endif
+
+	_MTC0	k0, MIPS_COP_0_ERROR_PC		# set return address
+	COP0_SYNC
+
+	mfc0	k0, MIPS_COP_0_STATUS		# restore status
+	li	k1, MIPS3_SR_DIAG_PE		# ignore further errors
+	or	k0, k1
+	mtc0	k0, MIPS_COP_0_STATUS		# restore status
+	COP0_SYNC
+
+	eret
+
+#if defined(MIPS64_XLS)
+	MSG("cache error @ EPC %#lx\nL1D_CACHE_ERROR_LOG %#lx\nL1D_CACHE_INTERRUPT %#lx\nstatus %#x, cause %#x");
+#else
+	MSG("cache error @ EPC 0x%x ErrCtl 0x%x CacheErr 0x%x");
+#endif
+	.set	at
+END(MIPSX(cache_exception))
+
+
+/*----------------------------------------------------------------------------
+ *
+ *	R4000 TLB exception handlers
+ *
+ *----------------------------------------------------------------------------
+ */
+
+#ifndef TSAR
+/*----------------------------------------------------------------------------
+ *
+ * mipsN_kern_tlb_miss --
+ *
+ *	Handle a TLB miss exception from kernel mode in kernel space.
+ *	The BaddVAddr, Context, and EntryHi registers contain the failed
+ *	virtual address.
+ *
+ * Results:
+ *	None.
+ *
+ * Side effects:
+ *	None.
+ *
+ *----------------------------------------------------------------------------
+ */
+LEAF_NOPROFILE(MIPSX(kern_tlb_miss))
+	.set	noat
+	_MFC0	k0, MIPS_COP_0_BAD_VADDR	# get the fault address
+#if VM_MIN_KERNEL_ADDRESS == MIPS_KSEG2_START
+	li	k1, VM_MIN_KERNEL_ADDRESS	# compute index
+#else
+	li	k1, VM_MIN_KERNEL_ADDRESS>>32	# compute index
+	dsll32	k1, k1, 0
+#endif
+	PTR_SUBU k0, k1
+	INT_L	k1, _C_LABEL(Sysmapsize)	# index within range?
+	PTR_SRL	k0, PGSHIFT
+	sltu	k1, k0, k1
+#ifdef newsmips
+	/* news5000 has ROM work area at 0xfff00000. */
+	bnez	k1, 1f
+	 nop
+	j	checkromwork
+	 nop					# - delay slot -
+1:
+#elif defined(MULTIPROCESSOR) && (MIPS64_RMIXL + MIPS64R2_RMIXL) > 0
+	beqz	k1, _C_LABEL(MIPSX(tlbunlock_kern_gen_exception)) # full trap processing
+	 nop
+#else
+	/*
+	 * If we are beyond the bounds of Sysmap, let trap panic for us.
+	 */
+	beqz	k1, _C_LABEL(MIPSX(kern_gen_exception)) # full trap processing
+	 nop					# - delay slot -
+#endif
+	PTR_L	k1, _C_LABEL(Sysmap)
+	PTR_SRL	k0, 1
+	PTR_SLL	k0, 3				# compute offset from index
+	PTR_ADDU k1, k0
+	INT_L	k0, 0(k1)			# get PTE entry
+	INT_L	k1, 4(k1)			# get odd PTE entry
+#if (MIPS32R2 + MIPS64R2 + MIPS64R2_RMIXL) > 0
+	_EXT	k0, k0, 0, WIRED_POS
+#else
+	_SLL	k0, k0, WIRED_SHIFT		# get rid of "wired" bit
+	_SRL	k0, k0, WIRED_SHIFT
+#endif
+	_MTC0	k0, MIPS_COP_0_TLB_LO0		# load PTE entry
+#if (MIPS32R2 + MIPS64R2 + MIPS64R2_RMIXL) > 0
+	_EXT	k1, k1, 0, WIRED_POS
+#else
+	_SLL	k1, k1, WIRED_SHIFT
+	_SRL	k1, k1, WIRED_SHIFT
+#endif
+	_MTC0	k1, MIPS_COP_0_TLB_LO1		# load PTE entry
+	COP0_SYNC
+	tlbwr					# write random TLB
+	COP0_SYNC
+#ifdef MIPS3
 	nop
 	nop
-	nop
-	PTR_LA	ra, MIPSX(user_return)
-	j	_C_LABEL(ast)			# ast()
-	 nop
+#endif
+#if defined(MULTIPROCESSOR) && (MIPS64_RMIXL + MIPS64R2_RMIXL) > 0
+	_MFC0	k1, MIPS_COP_0_OSSCRATCH, 2	# get tlbinfo lock addr
+	INT_S	zero, 0(k1)			# clear lock
+#endif
+	eret
 	.set	at
-END(MIPSX(user_intr))
-
+END(MIPSX(kern_tlb_miss))
 
 /*----------------------------------------------------------------------------
  *
- *	R4000 TLB exception handlers
- *
- *----------------------------------------------------------------------------
- */
-
-#ifndef TSAR
-/*----------------------------------------------------------------------------
- *
- * mips3_tlb_invalid_exception --
+ * mipsN_tlb_invalid_exception --
  *
  *	Handle a TLB invalid exception from kernel mode in kernel space.
@@ -1559,4 +1687,14 @@
 LEAF_NOPROFILE(MIPSX(tlb_invalid_exception))
 	.set	noat
+#if defined(MULTIPROCESSOR) && (MIPS64_RMIXL + MIPS64R2_RMIXL) > 0
+#define	TLB_INVALID_EXCEPTION_EXIT	_C_LABEL(MIPSX(tlbunlock_kern_gen_exception))
+	_MFC0	k1, MIPS_COP_0_OSSCRATCH, 2	# get tlblock addr
+	li	k0, __SIMPLELOCK_LOCKED
+1:	swapw	k0, k1				# set it to locked
+	bnez	k1, 1b				# was it locked?
+	 nop					#  if it was, try again
+#else
+#define	TLB_INVALID_EXCEPTION_EXIT	_C_LABEL(MIPSX(kern_gen_exception))
+#endif
 	_MFC0	k0, MIPS_COP_0_BAD_VADDR	# get the fault address
 #if VM_MIN_KERNEL_ADDRESS == MIPS_KSEG2_START
@@ -1566,98 +1704,133 @@
 	dsll32	k1, k1, 0
 #endif
-	bgez	k0, _C_LABEL(MIPSX(kern_gen_exception))	# full trap processing
-	 move	k1, MIPS_CURLWP
-	PTR_SUBU k0, k0, k1
+	bgez	k0, TLB_INVALID_EXCEPTION_EXIT	# full trap processing
+	 nop					# - delay slot -
+	PTR_SUBU k0, k1
 	INT_L	k1, _C_LABEL(Sysmapsize)	# index within range?
-	PTR_SRL	k0, k0, PGSHIFT
+	PTR_SRL	k0, PGSHIFT
 	sltu	k1, k0, k1
-	beqz	k1, _C_LABEL(MIPSX(kern_gen_exception))	# No. Failing beyond...
-	 move	k1, MIPS_CURLWP			# - delay slot -
+	beqz	k1, TLB_INVALID_EXCEPTION_EXIT	# No. Failing beyond...
+	 nop					# - delay slot -
 	PTR_L	k1, _C_LABEL(Sysmap)
-
-	PTR_SLL	k0, k0, 2			# compute offset from index
-	PTR_ADDU k1, k1, k0
+	PTR_SLL	k0, 2				# compute offset from index
+	PTR_ADDU k1, k0
 	tlbp					# Probe the invalid entry
 	COP0_SYNC
-	and	k0, k0, 4			# check even/odd page
+
+	mfc0	k0, MIPS_COP_0_TLB_INDEX
+#ifdef MIPS3
+	nop
+#endif
+	bltz	k0, TLB_INVALID_EXCEPTION_EXIT	# ASSERT(TLB entry exists)
+	 nop					# - delay slot -
+
+	and	k0, k1, 4			# check even/odd page
+#ifdef MIPS3
 	nop					# required for QED 5230
+#endif
 	bnez	k0, MIPSX(kern_tlbi_odd)
-	nop
-
-	mfc0	k0, MIPS_COP_0_TLB_INDEX
-	nop
-	bltz	k0, _C_LABEL(MIPSX(kern_gen_exception)) # ASSERT(TLB entry exists)
-	 move	k1, MIPS_CURLWP
+	 nop
+
 	INT_L	k0, 0(k1)			# get PTE entry
-
+#if (MIPS32R2 + MIPS64R2 + MIPS64R2_RMIXL) > 0
+	_EXT	k0, k0, 0, WIRED_POS
+#else
 	_SLL	k0, k0, WIRED_SHIFT		# get rid of "wired" bit
 	_SRL	k0, k0, WIRED_SHIFT
+#endif
 	_MTC0	k0, MIPS_COP_0_TLB_LO0		# load PTE entry
 	COP0_SYNC
 	and	k0, k0, MIPS3_PG_V		# check for valid entry
+#ifdef MIPS3
 	nop					# required for QED5230
-	beqz	k0, _C_LABEL(MIPSX(kern_gen_exception))	# PTE invalid
-	 move	k1, MIPS_CURLWP
+#endif
+	beqz	k0, TLB_INVALID_EXCEPTION_EXIT	# PTE invalid
+	 nop					# - delay slot -
+
 	INT_L	k0, 4(k1)			# get odd PTE entry
+	mfc0	k1, MIPS_COP_0_TLB_INDEX
+#if (MIPS32R2 + MIPS64R2 + MIPS64R2_RMIXL) > 0
+	_EXT	k0, k0, 0, WIRED_POS
+#else
 	_SLL	k0, k0, WIRED_SHIFT
-	mfc0	k1, MIPS_COP_0_TLB_INDEX
 	_SRL	k0, k0, WIRED_SHIFT
+#endif
 	sltiu	k1, k1, MIPS3_TLB_WIRED_UPAGES	# Luckily this is MIPS3_PG_G
 	or	k1, k1, k0
 	_MTC0	k0, MIPS_COP_0_TLB_LO1		# load PTE entry
 	COP0_SYNC
-	nop
-	nop					# required for QED5230
 	tlbwi					# write TLB
 	COP0_SYNC
+#ifdef MIPS3
 	nop
 	nop
-	nop
-	nop
-	nop
+#endif
 	eret
 
 MIPSX(kern_tlbi_odd):
-	mfc0	k0, MIPS_COP_0_TLB_INDEX
-	nop
-	bltz	k0, _C_LABEL(MIPSX(kern_gen_exception))	# assert(TLB Entry exists)
-	 move	k1, MIPS_CURLWP
 	INT_L	k0, 0(k1)			# get PTE entry
-
+#if (MIPS32R2 + MIPS64R2 + MIPS64R2_RMIXL) > 0
+	_EXT	k0, k0, 0, WIRED_POS
+#else
 	_SLL	k0, k0, WIRED_SHIFT		# get rid of wired bit
 	_SRL	k0, k0, WIRED_SHIFT
+#endif
 	_MTC0	k0, MIPS_COP_0_TLB_LO1		# save PTE entry
 	COP0_SYNC
 	and	k0, k0, MIPS3_PG_V		# check for valid entry
+#ifdef MIPS3
 	nop					# required for QED5230
-	beqz	k0, _C_LABEL(MIPSX(kern_gen_exception))	# PTE invalid
-	 move	k1, MIPS_CURLWP
+#endif
+	beqz	k0, TLB_INVALID_EXCEPTION_EXIT	# PTE invalid
+	 nop					# - delay slot -
+
 	INT_L	k0, -4(k1)			# get even PTE entry
+	mfc0	k1, MIPS_COP_0_TLB_INDEX
+#if (MIPS32R2 + MIPS64R2 + MIPS64R2_RMIXL) > 0
+	_EXT	k0, k0, 0, WIRED_POS
+#else
 	_SLL	k0, k0, WIRED_SHIFT
-	mfc0	k1, MIPS_COP_0_TLB_INDEX
 	_SRL	k0, k0, WIRED_SHIFT
+#endif
 	sltiu	k1, k1, MIPS3_TLB_WIRED_UPAGES	# Luckily this is MIPS3_PG_G
 	or	k1, k1, k0
 	_MTC0	k0, MIPS_COP_0_TLB_LO0		# save PTE entry
 	COP0_SYNC
-	nop
-	nop					# required for QED5230
 	tlbwi					# update TLB
 	COP0_SYNC
+#ifdef MIPS3
 	nop
 	nop
-	nop
-	nop
-	nop
+#endif
 	eret
+
+#if defined(MULTIPROCESSOR) && (MIPS64_RMIXL + MIPS64R2_RMIXL) > 0
+/*
+ * Before entering kern_gen_exception we need to clear the tlb lock that
+ * we locked.
+ */
+MIPSX(tlbunlock_kern_gen_exception):
+	_MFC0	k1, MIPS_COP_0_OSSCRATCH, 2	# get tlblock addr
+	b	_C_LABEL(MIPSX(kern_gen_exception))
+	 INT_S	zero, 0(k1)			# clear lock
+#endif
+
 END(MIPSX(tlb_invalid_exception))
 
-/*----------------------------------------------------------------------------
- *
- * mipsN_kernel_tlb_miss --
- *
- *	Handle a TLB miss exception from kernel mode in kernel space.
- *	The BaddVAddr, Context, and EntryHi registers contain the failed
- *	virtual address.
+/*
+ * Mark where code entered from exception hander jumptable
+ * ends, for stack traceback code.
+ */
+
+	.globl	_C_LABEL(MIPSX(exceptionentry_end))
+_C_LABEL(MIPSX(exceptionentry_end)):
+
+/*--------------------------------------------------------------------------
+ *
+ * mipsN_tlb_set_asid --
+ *
+ *	Write the given pid into the TLB pid reg.
+ *
+ *	void mipsN_tlb_set_asid(uint32_t pid)
  *
  * Results:
